'''
>>> import pjm
>>> a = pjm.ProcessJob()
Entering QueuedAndPooled
>>>
>>> a.open()
Logging start
jyugem::bee::task::open
jyugem::bee::state_task::svc
0
>>> a.update("alloc")
Exiting QueuedAndPooled
1
Entering Active
Entering Executing
Entering SettingUp
Exiting SettingUp
Entering WaitingForStart
<message="S6F11">
  <ceid type="ascii">Job Waiting For Start</ceid>
  <list>
    <report type="ascii">ProcessJob</report>
    <report type="ascii">2004030100103500</report>
  <list>
</message>

>>> a.current_state()
'WaitingForStart'
>>> a.update("start")
Exiting WaitingForStart
Entering Processing
<message="S16F11">
  <ceid type="ascii">Processing</ceid>
  <list>
    <report type="ascii">ProcessJob</report>
    <report type="ascii">2004030100112800</report>
  <list>
</message>

>>> a.current_state()
'Processing'
>>> a.update("stop")
Exiting Processing
Exiting Executing
Entering Stopping
1
>>> a.current_state()
'Stopping'
>>> a.update("stopped")
Exiting Stopping
Exiting Active
Entering Departed
<message="S6F11">
  <ceid type="ascii">Departed</ceid>
  <list>
    <report type="ascii">ProcessJob</report>
    <report type="ascii">2004030100122100</report>
  <list>
</message>

>>> a.current_state()
'Departed'
>>> a = 0
Exiting Departed
>>>
'''

import pjm
a = pjm.ProcessJob()

a.open()

a.update("alloc")

a.current_state()

a.update("start")

a.current_state()

# a.update("complete")
a.update("stop")

a.current_state()

a.update("stopped")

a = 0
