// $Id$

//=============================================================================
/**
 *  @file    booster.h
 *
 *  @author Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUGEM_BEE_CSTR_ID_H
#define JYUGEM_BEE_CSTR_ID_H

#ifdef _MSC_VER
#pragma warning( disable: 4244 )
#endif

namespace jyugem { namespace bee
{

struct cstr_id
{
  cstr_id() : m_name(null), m_id(0) {}
  cstr_id(const BCHAR * nm, int id) : m_name(nm), m_id(id) {}
  cstr_id(const cstr_id& rhs) : m_name(rhs.m_name), m_id(rhs.m_id) {}
  ~cstr_id() {}

  cstr_id& operator=(const cstr_id& rhs)
  {
    if (this == &rhs)
      return *this;
    m_name = rhs.m_name;
    m_id = rhs.m_id;
    return *this;
  }

  friend bool operator==(const cstr_id& lhs, const cstr_id& rhs);
  friend bool operator< (const cstr_id& lhs, const cstr_id& rhs);

  const BCHAR * name() const { return m_name; }
  int   id()  { return m_id; }
  bool  nil() { return (m_name == null); }

protected:
  const BCHAR * m_name;           // if m_str is null, mean table end
  int   m_id;
};

inline bool operator==(const cstr_id& lhs, const cstr_id& rhs)
{
  return (lhs.m_id == rhs.m_id);
}

inline bool operator<(const cstr_id& lhs, const cstr_id& rhs)
{
  return (lhs.m_id < rhs.m_id);
}


} } // *namespace* jyugem::bee

#endif
