/* $Id$ */

//=============================================================================
/**
 *  @file  hex.h
 *
 *  @author Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 1998-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUBEM_BEE_UTIL_HEX_H
#define JYUBEM_BEE_UTIL_HEX_H

#include "jyugem/bee.h"
#include <boost/tokenizer.hpp>

using namespace jyugem::bee;

namespace jyugem { namespace bee { namespace util
{

//
//
class BEE_Export hex
{
public:
  typedef boost::tokenizer<boost::char_separator<char> > Tok;

  template<typename T>
  static vector<T> to_bin(const std::string& hexstr)
  {
    vector<T> hexbin;
    boost::char_separator<char> sep(" \t\n"); // default constructed
    Tok tok(key, sep);  // default separater are space or punctuation
    for (Tok::iterator beg = tok.begin(); beg != tok.end(); ++beg)
    {
      T data = static_cast<T>(strtoul(beg->c_str(), 0, 16));
      //
      // endian
      //
      hexbin.push_back(data);
    }
    return hexbin;
  }

  template<>
  static bee::binary to_bin(const std::string& hexstr)
  {
    bee::binary hexbin;
    boost::char_separator<char> sep(" \t\n"); // default constructed
    Tok tok(key, sep);  // default separater are space or punctuation
    for (Tok::iterator beg = tok.begin(); beg != tok.end(); ++beg)
    {
      byte data = static_cast<byte>(strtoul(beg->c_str(), null, 16));
      hexbin.push_back(data);
    }
    return hexbin;
  }
};

} } } // namespace - jyugem::bee::util

#endif  /* JYUBEM_BEE_UTIL_HEX_STRING_H */
