// $Id$

//=============================================================================
/**
 *  @file  viewed_state.h
 *
 *  @author Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2003-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUGEM_BEE_VIEWED_STATE_H
#define JYUGEM_BEE_VIEWED_STATE_H

#include "jyugem/bee.h"

namespace jyugem { namespace bee
{

#if 1
#define TRACE_STATE_ENTER()                                               \
  do {                                                                    \
    m_nameptr = custom_dynamic_type_ptr< cstr_id >();                     \
    ACE_DEBUG((LM_DEBUG, ACE_TEXT("Entering %s\n"), m_nameptr->name()));  \
  } while (0)

#define TRACE_STATE_EXIT(x)                                               \
  do {                                                                    \
    if (m_nameptr != null)                                                \
      ACE_DEBUG((LM_DEBUG, ACE_TEXT("Exiting %s\n"), m_nameptr->name())); \
  } while (0)

#else
#define TRACE_STATE_ENTER()                                               \
  do {                                                                    \
    m_nameptr = custom_dynamic_type_ptr< cstr_id >();                     \
  } while (0)
#define TRACE_STATE_EXIT(x)
#endif

//
// Named state class
//
struct named_state
{
  named_state(const cstr_id * strid = null) : m_nameptr(strid) {}
  ~named_state()
  {
    TRACE_STATE_EXIT(m_nameptr);
  }

// variables
  const cstr_id * m_nameptr;
};

//
// Viewed State
//
template< unsigned int orthogonalRegion = 0 >
struct viewed_state : named_state
{
  viewed_state() : named_state() {}
};


} } // *namespace* jyugem::bee

#endif
