// $Id$

//=============================================================================
/**
 *  @file    service_request.h
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2001-2003 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#ifndef JYUGEM_GEM_SERVICE_REQUEST_H
#define JYUGEM_GEM_SERVICE_REQUEST_H

#include "jyugem/bee/trigger_request.h"

namespace bee = jyugem::bee;

namespace jyugem { namespace gem
{

// Forword declaration
class bee::trigger;


//------------------------------------------------------------------------------
//
// Asynchronous method for task
//
//------------------------------------------------------------------------------
template<class T>
class service_request : public trigger_request
{
public:
    service_request(trigger * trig, task * task = null)
            : trigger_request(trig, task) {}
    virtual ~service_request() {}

    virtual int call()
    {
        TRACE_DEBUG((_TX("Not supportted.\n")));
        return 0;
    }

protected:
    service_request() : trigger_request() {}

//
protected:
    T * m_argv;
};


} } // *namespace* jyugem::bee

#endif  /* JYUGEM_GEM_SERVICE_REQUEST_H */
