// $Id$

//=============================================================================
/**
 *  @file    filebase.cpp
 *
 *  @author  Fukasawa Mitsuo
 *
 *
 *    Copyright (C) 2001-2004 BEE Co.,Ltd. All rights reserved.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
//=============================================================================

#define BEE_BUILD_DLL

#include "boost/filesystem/operations.hpp"
#include "jyugem/bee/filebase.h"

namespace fs = boost::filesystem;

namespace jyugem { namespace bee
{

//-----------------------------------------------------------------------------
// Make file name (static)
//-----------------------------------------------------------------------------
int filebase::make_pathname(const std::string& dir, const std::string& fname,
                            const std::string& ext, std::string& pathname)
{
  std::string path = dir;
  if (path.at(dir.size() - 1) != '/')
  {
    path.append(1, '/');
  }
  path.append(fname);
  if (ext.size() > 0)
  {
    if (ext.at(0) != '.')
    {
      path.append(1, '.');
    }
    path.append(ext);     // path that make file.
  }
  // posix to native
  fs::path full_path(fs::initial_path());
  full_path = fs::system_complete(fs::path(path, fs::native));
  pathname = full_path.native_file_string();
  return 0;
}

//-----------------------------------------------------------------------------
// Dump
//-----------------------------------------------------------------------------
void filebase::dump() const
{
  ACE_DEBUG((LM_DEBUG, ACE_TEXT("path = %s\n"), m_path.c_str()));
}

} } // *namespace* jyugem::bee
